//***********************************************************
//* Author: David Welford-Costelloe
//* Web   : http://www.welford-costelloe.com
//*
//************************************************************
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.ServiceProcess;
using System.Windows.Forms;
using System.Text;

using System.Data;

namespace Service_Tester
{
	/// <summary>
	/// Main Form for Service Viewer
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.StatusBarPanel statusBar;
		private System.Windows.Forms.StatusBarPanel statusBarDate;
		private System.Windows.Forms.StatusBarPanel statusBarTime;
		private System.Windows.Forms.Timer tmrStatus;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuExit;

		// Just for you Chris :-)
		private Utilities helper = new Utilities();

		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.Timer tmrService;
		private System.Windows.Forms.MenuItem mnuInfo;
		private System.Windows.Forms.MenuItem mnuAbout;
		protected System.Windows.Forms.ListView listView;
		protected System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.CheckBox chkAuto;
		private ServiceController  [] controllers;
		
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			controllers = ServiceController.GetServices(helper.GetMachineName);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.statusBar = new System.Windows.Forms.StatusBarPanel();
			this.statusBarDate = new System.Windows.Forms.StatusBarPanel();
			this.statusBarTime = new System.Windows.Forms.StatusBarPanel();
			this.tmrStatus = new System.Windows.Forms.Timer(this.components);
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuExit = new System.Windows.Forms.MenuItem();
			this.mnuInfo = new System.Windows.Forms.MenuItem();
			this.mnuAbout = new System.Windows.Forms.MenuItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.tmrService = new System.Windows.Forms.Timer(this.components);
			this.listView = new System.Windows.Forms.ListView();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.chkAuto = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.statusBar)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarDate)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarTime)).BeginInit();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 467);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.statusBar,
																						  this.statusBarDate,
																						  this.statusBarTime});
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(832, 22);
			this.statusBar1.TabIndex = 1;
			// 
			// statusBar
			// 
			this.statusBar.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBar.ToolTipText = "Current System Status";
			this.statusBar.Width = 796;
			// 
			// statusBarDate
			// 
			this.statusBarDate.Alignment = System.Windows.Forms.HorizontalAlignment.Center;
			this.statusBarDate.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.statusBarDate.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.Raised;
			this.statusBarDate.ToolTipText = "Current System Date";
			this.statusBarDate.Width = 10;
			// 
			// statusBarTime
			// 
			this.statusBarTime.Alignment = System.Windows.Forms.HorizontalAlignment.Center;
			this.statusBarTime.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.statusBarTime.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.Raised;
			this.statusBarTime.ToolTipText = "Current System Time";
			this.statusBarTime.Width = 10;
			// 
			// tmrStatus
			// 
			this.tmrStatus.Enabled = true;
			this.tmrStatus.Tick += new System.EventHandler(this.tmrStatus_Tick);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFile,
																					  this.mnuInfo});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuExit});
			this.mnuFile.Text = "&File";
			// 
			// mnuExit
			// 
			this.mnuExit.Index = 0;
			this.mnuExit.Text = "E&xit";
			this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
			// 
			// mnuInfo
			// 
			this.mnuInfo.Index = 1;
			this.mnuInfo.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuAbout});
			this.mnuInfo.Text = "I&nformation";
			// 
			// mnuAbout
			// 
			this.mnuAbout.Index = 0;
			this.mnuAbout.Text = "&About";
			this.mnuAbout.Click += new System.EventHandler(this.mnuAbout_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// tmrService
			// 
			this.tmrService.Interval = 30000;
			this.tmrService.Tick += new System.EventHandler(this.tmrService_Tick);
			// 
			// listView
			// 
			this.listView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.listView.Location = new System.Drawing.Point(8, 128);
			this.listView.Name = "listView";
			this.listView.Size = new System.Drawing.Size(816, 328);
			this.listView.TabIndex = 3;
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Controls.Add(this.chkAuto);
			this.groupBox1.Location = new System.Drawing.Point(8, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(816, 120);
			this.groupBox1.TabIndex = 6;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Options";
			// 
			// chkAuto
			// 
			this.chkAuto.Location = new System.Drawing.Point(8, 24);
			this.chkAuto.Name = "chkAuto";
			this.chkAuto.Size = new System.Drawing.Size(232, 24);
			this.chkAuto.TabIndex = 1;
			this.chkAuto.Text = "Auto Refresh (30 Seconds)";
			this.chkAuto.CheckedChanged += new System.EventHandler(this.chkAuto_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(832, 489);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.listView);
			this.Controls.Add(this.statusBar1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "David\'s Service Tester";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.statusBar)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarDate)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarTime)).EndInit();
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		/// <summary>
		/// This is where we start
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.statusBar.Text = "Welcome to David's Windows Service Viewer C# sample Code.";
			// Set Up Application
			setUpApplication();
			// Build the headers
			BuildListView();
			// Load with services
			ListServices();
		}


		/// <summary>
		/// Set the Time on the Status Bar
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void tmrStatus_Tick(object sender, System.EventArgs e)
		{
			this.statusBarTime.Text = System.DateTime.Now.ToShortTimeString(); 
		}
		
		/// <summary>
		/// Go get all the services available for the local machine
		/// </summary>
		private void ListServices() 
		{
			// Future use - bad habit of mine to think ahead
			//bool blnLock = listView.Items.Count > 0;
			this.statusBar.Text = "Looking at Windows Services...";
			ServiceController[] services;
			// Set the machine name to current system
			services = ServiceController.GetServices(helper.GetMachineName);
			// Check for anything in the listview
			if (listView.Items.Count > 0 )
			{
				listView.Items.Clear();
			}
			for (int i = 0; i <  services.Length; i++)
			{
				 
				// Define the list items
				ListViewItem lvi = new ListViewItem("",GetImageForView(i));
				lvi.SubItems.Add(services[i].ServiceName);
				lvi.SubItems.Add(services[i].DisplayName);
				//lvi.SubItems.Add(services[i].ServiceType.ToString());
				//lvi.SubItems.Add(services[i].ServicesDependedOn.ToString());
				lvi.SubItems.Add(GetServiceStatus(i).ToString());
				lvi.SubItems.Add(RetServiceStopStart(i));
				lvi.SubItems.Add(RetServiceCanShutDown(i));
				lvi.SubItems.Add(RetServiceCanPause(i));
				

				// Add the list items to the ListView
				listView.Items.Add(lvi);
				// Reduces the flicker hope this is better in 2005
				this.Update();
				this.statusBar.Text = "Services load completed.";
			}
		}
	
		
		/// <summary>
		/// Ask the service current status from the service.
		/// </summary>
		/// <param name="i"></param>
		/// <returns>string</returns>
		private string GetServiceStatus(int i )
		{
			string sType = "";
			ServiceControllerStatus status = controllers[i].Status;
			switch (status)
			{
				case ServiceControllerStatus.ContinuePending:
					sType = "Continue Pending";
					break;
				case ServiceControllerStatus.Paused:
					sType = "Paused";
					break;
				case ServiceControllerStatus.PausePending:
					sType = "Pause Pending";
					break;
				case ServiceControllerStatus.Running:
					sType = "Running";
					break;
				case ServiceControllerStatus.StartPending:
					sType = "Start Pending";
					break;
				case ServiceControllerStatus.Stopped:
					sType = "Stopped";
					break;
				case ServiceControllerStatus.StopPending:
					sType = "Stop Pending";
					break;
				default:
					sType = "Unknown";
					break;
			}
			
			return sType;
		}


		

/// <summary>
/// Can the service be stopped or started if so return Yes or No
/// </summary>
/// <param name="i"></param>
/// <returns>string</returns>
		private string RetServiceStopStart(int i)
		{
			
			// Can the status of this service be stopped or not.
			bool blnCanStop = controllers[i].CanStop;
			return (blnCanStop ? "Yes" : "No");
		}
		


/// <summary>
/// Check if service can be shutdown or not
/// </summary>
/// <param name="i"></param>
/// <returns>string</returns>
		private string RetServiceCanShutDown(int i)
		{
			bool blnCanShutDown = controllers[i].CanShutdown;
			return (blnCanShutDown ? "Yes" : "No");
		}

        
/// <summary>
/// Check service if it can pause or not.
/// </summary>
/// <param name="i"></param>
/// <returns>string</returns>
		private string RetServiceCanPause(int i)
		{
			// Does the status if the service can be paused and contiued.
			bool blnPauseNContinue = controllers[i].CanPauseAndContinue;
			
			return (blnPauseNContinue ? "Yes" : "No");
			
		}

        /// <summary>
        /// Exit when menu option clicked
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
		private void mnuExit_Click(object sender, System.EventArgs e)
		{
			Environment.Exit(0);
		}

		/// <summary>
		/// Build the list view columns
		/// </summary>
		private void BuildListView()
		{
			
		
			this.statusBar.Text = "Building Listview columns";
			// Set the view to show details.
			listView.View = View.Details;
			listView.SmallImageList = this.imageList1;
			// Allow the user to sort columns.
			listView.AllowColumnReorder = false;

			// Select the item and subitems 
			listView.FullRowSelect = true;

			// Display grid lines.
			listView.GridLines = true;

			// Attach Subitems to the ListView
			listView.Columns.Add("", 30, HorizontalAlignment.Left);
			listView.Columns.Add("Service Name", 100, HorizontalAlignment.Left);
			listView.Columns.Add("Service Description", 500, HorizontalAlignment.Left);
			//listView.Columns.Add("Dependent Services", 500, HorizontalAlignment.Left);
			listView.Columns.Add("Status", 70, HorizontalAlignment.Left);
			listView.Columns.Add("Can Stop Service", 70, HorizontalAlignment.Left);
			listView.Columns.Add("Can ShutDown Service", 100, HorizontalAlignment.Left);
			listView.Columns.Add("Can Pause Service", 100, HorizontalAlignment.Left);
		
		}


/// <summary>
/// Set the correct Icon based upon service status. 
/// </summary>
/// <param name="i"></param>
/// <returns>string</returns>
		private int GetImageForView(int i)
		{
			string sType = GetServiceStatus(i);
			int intRet = 0;

			switch (sType)
			{
				case "Continue Pending":
					intRet = 1;
					break;
				case "Paused":
					intRet = 5;
					break;
				case "Pause Pending":
					intRet = 6;
					break;
				case "Running":
					intRet = 4;
					break;
				case "Start Pending":
					intRet = 7;
					break;
				case "Stopped":
					intRet = 3;
					break;
				case "Stop Pending":
					intRet = 0;
					break;
				default:
					intRet = 2;
					break;
		
			}
			return intRet;
		}

/// <summary>
/// If Timer Ticker is enabled re-load service list
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
		private void tmrService_Tick(object sender, System.EventArgs e)
		{
			// Load if timer request is set
			ListServices();
		}

/// <summary>
/// Configure the application here
/// </summary>
		private void setUpApplication()
		{
			// Eenable or disable timer refresh
			this.tmrService.Enabled = this.chkAuto.Checked;

			// Set Data and Time for StatusBar 
			this.statusBarDate.Text  = System.DateTime.Today.ToLongDateString();  
			this.statusBarTime.Text  = System.DateTime.Now.ToShortTimeString();
		}

			
/// <summary>
/// Tell the timer to set or not set. Send message to Statusbar
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
		private void chkAuto_CheckedChanged(object sender, System.EventArgs e)
		{
			
			this.tmrService.Enabled = this.chkAuto.Checked;
			this.statusBar.Text = "Auto Refresh set to: " + (this.chkAuto.Checked ? "On" : "Off");
		}

/// <summary>
/// Loads The Menu About
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
		private void mnuAbout_Click(object sender, System.EventArgs e)
		{
			// Load up the about form and send a busy cursor 
			this.Cursor = Cursors.WaitCursor;
			About frmAbout = new About();
			frmAbout.ShowDialog(this);
			// Set Cursor back to default
			this.Cursor = Cursors.Default;
		}

		
	}

}
